<template>
  <div class="contract-locations">
    <div class="contract-locations__header">
      <button data-qa="btnContractLocationsHeader" @click="setViewState(VIEW_STATES.main)">
        <i class="icon chevron-left" />
        {{ serviceTitleByType }}
      </button>
      <div class="title">
        {{ service.serviceTitle }}
      </div>
    </div>

    <ObTable
      ref="locationTable"
      :columns="columns"
      :page-limit="15"
      :remote-opt="{
        method: api.contract.getServiceLocations,
        arguments: {
          uuid: service.uuid
        }
      }"
      :remote-trigger="service.geography === 'WHERE' ? service.uuid : undefined"
      :show-add-button="isDraft"
      :functional-panel="true"
      add-button-text="Добавить локацию"
      data-qa="contractLocationsTable"
      @add="onAddLocation"
      @select="selectLocation"
    >
      <div slot="dropdownMenu" slot-scope="{ data }">
        <ObMenuDropdown
          :items="getDropdownItems(data)"
        />
      </div>
      <template slot="noneContent">
        <div class="title">Сейчас услуга действует для всех локаций по указанному тарифу.</div>
        <ObButton
          v-if="isDraft"
          label="Добавить локацию"
          type="flat"
          data-qa="addLocation"
          @click="onAddLocation"
        />
      </template>
    </ObTable>
    <ObModal
      ref="locationModal"
      :title-second="titleSecondModal"
      :title="titleModal"
      size="large"
      data-qa="contractLocation"
    >
      <LocationForm
        :data-source="editedData"
        @on-disable-location="deleteLocation"
        @submit="saveLocation"
      />
    </ObModal>
  </div>
</template>

<script>
import api from '@/api'
import { mapState, mapGetters, mapMutations } from 'vuex'
import ObTable from 'common-components/src/obComponents/obTable'
import LocationForm from '@/components/Contract/detail/services/locations/Form'
import ObModal from 'common-components/src/obComponents/obModal'
import ObButton from 'common-components/src/obComponents/obButton'
import ObMenuDropdown from 'common-components/src/obComponents/obMenuDropdown'
import { formatNumber } from 'common-components/src/helpers/common'
import moment from 'moment';

export default {
  name: 'ContractLocationsList',
  components: {
    ObTable,
    LocationForm,
    ObModal,
    ObMenuDropdown,
    ObButton
  },
  data () {
    return {
      api,
      editedData: {},
      listFilter: {
        uuid: 'from'
      },
      listFilters: [
        {
          uuid: 'from',
          title: 'Откуда'
        }
      ],
      date: {
        uuid: 'today'
      },
      dates: [
        {
          uuid: 'today',
          title: moment().format('DD.MM.YYYY')
        }
      ],
      switcher: false
    }
  },
  computed: {
    ...mapState({
      contract: state => state.contract.contract,
      service: state => state.contract.editedService
    }),
    ...mapGetters({
      isDraft: 'contract/isDraft',
      VIEW_STATES: 'contract/VIEW_STATES',
      isVatPayer: 'contract/isDoerVatPayer'
    }),
    columns () {
      return [
        {
          title: 'Локация',
          key: 'locationTitle',
          html: (data) => {
            return data.locationTitle
          }
        },
        {
          title: 'Тариф (без ндс)',
          key: 'tariffWithoutVat',
          html: (data) => this.tariffHtml(data)
        },
        {
          title: this.getNdsTitle(),
          key: 'vatAmount',
          html: (data) => this.ndsHtml(data)
        },
        {
          title: 'Итоговый тариф',
          key: 'tariff',
          html: (data) => this.totalPrice(data)
        },
        {
          title: ' ',
          slotName: 'dropdownMenu',
          sortDisable: true,
          action: true
        }
      ]
    },
    serviceTitleByType () {
      if (!this.service.type) return ''
      let types = [
        {
          uuid: 'SIMPLE',
          title: 'Базовые'
        },
        {
          uuid: 'MULTISTOP',
          title: 'Мультистоповые',
          isDisabled: true
        },
        {
          uuid: 'MULTIMODAL',
          title: 'Мультимодальные',
          isDisabled: true
        },
        {
          uuid: 'ADDITIONAL',
          title: 'Дополнительные',
          isDisabled: true
        }
      ]

      return types.find((item) => item.uuid === this.service.type).title
    },
    titleModal () {
      return this.editedData.locationUuid ? `Локация «${this.editedData.locationTitle}»` : 'Локация'
    },
    titleSecondModal () {
      if (!this.isDraft) {
        return 'Просмотр'
      }
      return this.editedData.locationUuid ? 'Редактирование' : 'Добавление'
    }
  },
  methods: {
    ...mapMutations({
      setViewState: 'contract/setViewState'
    }),
    onAddLocation () {
      this.editedData = {}
      this.$refs.locationModal.open()
    },
    async deleteLocation ({ uuid }) {
      try {
        await api.contract.deleteLocation({ uuid })
        this.$notification({
          type: 'system_notification_success',
          message: `Локация удалена`
        })
        setTimeout(() => {
          this.$refs.locationTable.loadData()
        }, 500)
      } catch (e) {
        this.$notification({
          type: 'system_notification_error',
          message: `Ошибка удаления локации`
        })
      }
    },
    async saveLocation ({ formData }) {
      formData.serviceUuid = this.service.uuid
      try {
        if (this.editedData.uuid) {
          await api.contract.updateLocation({ data: formData, uuid: this.editedData.uuid })
        } else {
          await api.contract.createLocation({ data: { ...formData, serviceUuid: this.service.uuid } })
        }
        this.$notification({
          type: 'system_notification_success',
          message: `Локация ${this.editedService ? 'обновлена' : 'добавлена'}`
        })
        this.$refs.locationModal.close()
        setTimeout(() => {
          this.$refs.locationTable.loadData()
        }, 500)
      } catch (e) {
        this.$notification({
          type: 'system_notification_error',
          message: `Ошибка ${this.editedService ? 'обновления' : 'добавления'} локации`
        })
      }
    },
    async selectLocation ({ uuid }) {
      try {
        let res = await api.contract.getLocationDetail({ uuid })
        this.editedData = { ...res }
        this.$refs.locationModal.open()
      } catch (e) {
        this.$notification({
          type: 'system_notification_error',
          message: `Ошибка загрузки данных локации`
        })
      }
    },
    getDropdownItems (data) {
      if (!this.isDraft) {
        return []
      }
      return [
        {
          title: 'Удалить локацию',
          className: 'menu-button-danger',
          method: () => this.deleteLocation({ uuid: data.item.uuid })
        }
      ]
    },
    toHtml (data) {
      return `<div class="cell-to-location"><i class="icon ${data.to_icon}"></i><span>${data.to}</span></div>`
    },
    tariffHtml (data) {
      if (!data.tariffWithoutVat) {
        return `<span class="-gray-slate">Онлайн-цена</span>`
      }
      return `<span>${formatNumber(data.tariffWithoutVat / 100, { dot: 2 })}</span> <span class="-gray-window">₽</span>`
    },
    ndsHtml (data) {
      return this.isVatPayer ? (formatNumber(data.vatAmount / 100, { dot: 2 }) + ' ₽') : `<span class="-gray-window">Не облагается</span>`
    },
    totalPrice(data) {
      if (!data.tariff) {
        return `<span class="-gray-slate">Онлайн-цена</span>`
      }
      return `<span>${formatNumber(data.tariff / 100, { dot: 2 })}</span> <span class="-gray-window">₽</span>`
    },
    tableGroupTitleHtml (value) {
      return `<div class="cell-to-location"><i class="icon city-sm"></i><span>${value}</span></div>`
    },
    getNdsTitle () {
      if (!this.isVatPayer) {
        return 'НДС'
      }
      return this.service.isVatInclude
        ? 'в том числе НДС ' + (this.service.vatValue || 20) + '%'
        : 'НДС ' + (this.service.vatValue || 20) + '%'
    }
  }
}
</script>

<style lang="scss" scoped>
  .contract-locations {
    display: flex;
    flex-direction: column;
    height: 100%;
    background-color: $background-white;
    border-radius: 3px;
    &__header {
      display: flex;
      align-items: center;
      min-height: 60px;
      padding: 20px 13px;
      border-bottom: 1px $color-grey-border solid;
      button {
        display: flex;
        align-items: center;
        margin: 0;
        padding: 5px;
        background-color: transparent;
        border: none;
        color: $color-blue-navy-blue;
        font-size: 16px;
        line-height: 20px;
        outline: none;
        cursor: pointer;
        .icon {
          margin-right: 10px;
          font-size: 18px;
        }
      }
      .title {
        margin-left: 50px;
        font-family: Roboto, sans-serif;
        font-style: normal;
        font-weight: normal;
        font-size: 16px;
        line-height: 20px;
        letter-spacing: 0.2px;
        color: $color-text-base;
      }
    }
    &-functional {
      display: flex;
      align-items: center;
      flex: 1;
    }
    &__select-inline {
      padding: 7px 12px;
      margin-right: 12px;
      background: $lavender;
      border-radius: 19px;
      &.disabled {
        background: $color-white-lilac;
        pointer-events: none;
      }
      span {
        font-size: 14px;
        line-height: 18px;
        letter-spacing: 0.2px;
        color: $color-grey-span;
      }
    }
    &::v-deep {
      .ob-func-panel__controls-side:last-child {
        flex-grow: 2;
        justify-content: space-between;
      }
    }
  }
</style>

<style lang="scss">
  @import '~common-components/src/static/css/variables';
  .contract-locations {
    table {
      min-width: auto!important;
    }
    .menu-button-danger {
      button {
        color: $color-error;
      }
    }

    .ob-table-inner {
      flex-grow: 2;
      .ob-menu-dropdown-container:not(.--opened) {
        opacity: 0;
        pointer-events: none;
      }
      tr:hover {
        .ob-menu-dropdown-container {
          opacity: 1;
          pointer-events: all;
        }
      }
      td {
        &:last-child {
          .td-container {
            justify-content: flex-end;
          }
        }
      }
      .cell-to-location {
        display: flex;
        align-items: center;
        .icon {
          margin-right: 10px;
          font-size: 14px;
          color: $color-blue-navy-blue;
        }
      }
    }
  }
</style>
